=== debian/changelog ===
openbao (2.3.1-1kaisen) kaisen-packages; urgency=medium

  * Import the 2.3.1 release
  * Update the no-display-HEAD-for-version quilt patch
  * Bump the golang-go version required to build

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sat, 09 Aug 2025 20:15:51 +0200

openbao (2.1.0-1kaisen) kaisen-packages; urgency=medium

  * Import the 2.1.0 release

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Wed, 15 Jan 2025 16:07:39 +0200

openbao (2.0.3-1kaisen) kaisen-packages; urgency=medium

  * Import the 2.0.3 release
  * Update the no-display-HEAD-for-version quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Tue, 19 Nov 2024 02:48:37 +0200

openbao (2.0.0-1kaisen) kaisen-packages; urgency=medium

  * Initial release

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Wed, 24 Jul 2024 10:25:23 +0200
